import es, cfglib

location = {}

info = es.AddonInfo()
info.name = 'Save Spawn'
info.version = '1.0'
info.url = 'http://addons.eventscripts.com/addons/view/SaveSpawn'
info.basename = 'savespawn'
info.author = 'Deathyy'

es.ServerVar('savespawn_ver', info['version'], 'A simple savespawn script. "!savespawn" saves your spawn location and "!delspawn" deletes your saved location.').makepublic()

config = cfglib.AddonCFG(es.getAddonPath('savespawn') + "/settings.cfg")

config.text('=====================================')
config.text('======== SAVE SPAWN SETTINGS ========')
config.text('=====================================')

savespawn_admin_only = config.cvar('savespawn_admin_only',     1, '1/0 : Only certain admins can use/Anybody can use') # 0 = Players can use the !savespawn/!delspawn feature. 1 = Only admins can use the !savespawn/!delspawn feature.
savespawn_admins = config.cvar('savespawn_admins',     'STEAM_0:1:25511182', 'STEAMID\'s that can use the !savespawn/!delspawn feature. Only if it is enabled!')

config.write()

def load():
    config.execute()

def player_activate(ev):
    userid = int(ev['userid'])
    if not userid in location:
        location[userid] = {}
        location[userid]['x'] = {}
        location[userid]['y'] = {}
        location[userid]['z'] = {}
        location[userid]['enabled'] = {}
        
def player_say(ev):
    userid = int(ev['userid'])
    if ev['text'] == '!savespawn':
        if savespawn_admin_only == 1:
            admins = admins = str(savespawn_admins).replace(' ', '').strip(',')
            if es.getplayersteamid(userid) in str(savespawn_admins):
                org = es.getplayerprop(userid, 'CBaseEntity.m_vecOrigin')
                x, y, z = es.splitvectorstring(org)
                location[userid]['x'] = x
                location[userid]['y'] = y
                location[userid]['z'] = z
                location[userid]['enabled'] = 1
                es.tell(userid, '#multi', '#green[Save Spawn] #defaultSpawn saved : %s %s %s' % (location[userid]['x'], location[userid]['y'], location[userid]['z']))
            else:
                es.tell(userid, '#multi', '#green[Save Spawn] #defaultYou must be a admin to use this feature!!')
        elif savespawn_admin_only == 0:
            org = es.getplayerprop(userid, 'CBaseEntity.m_vecOrigin')
            x, y, z = es.splitvectorstring(org)
            location[userid]['x'] = x
            location[userid]['y'] = y
            location[userid]['z'] = z
            location[userid]['enabled'] = 1
            es.tell(userid, '#multi', '#green[Save Spawn] #defaultSpawn saved : %s %s %s' % (location[userid]['x'], location[userid]['y'], location[userid]['z']))
    if ev['text'] == '!delspawn':
        if savespawn_admin_only == 1:
            admins = admins = str(savespawn_admins).replace(' ', '').strip(',')
            if es.getplayersteamid(userid) in str(savespawn_admins):
                del location[userid]['x']
                del location[userid]['y']
                del location[userid]['z']
                location[userid]['enabled'] = 0
                es.tell(userid, '#multi', '#green[Save Spawn] #defaultPosition Deleted')
            else:
                es.tell(userid, '#multi', '#green[Save Spawn] #defaultYou must be a admin to use this feature!!')
        elif savespawn_admin_only == 0:
            del location[userid]['x']
            del location[userid]['y']
            del location[userid]['z']
            location[userid]['enabled'] = 0
            es.tell(userid, '#multi', '#green[Save Spawn] #defaultPosition Deleted')
      
def player_spawn(ev):
    userid = int(ev['userid'])
    if userid in location:
        if location[userid]['enabled'] == 1:
            es.server.cmd('es_xsetpos %s %s %s %s' % (userid, location[userid]['x'], location[userid]['y'], location[userid]['z']))
            es.tell(userid, '#multi', '#green[Save Spawn] #defaultSaved spawn restored : %s %s %s' % (location[userid]['x'], location[userid]['y'], location[userid]['z']))